package org.ow2.jones.demo.booking.common;

import java.io.IOException;
import java.util.Set;
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

public class MonitoringHandler implements SOAPHandler<SOAPMessageContext> {

    public Set<QName> getHeaders() {
        // TODO Auto-generated method stub
        return null;
    }

    public boolean handleMessage(SOAPMessageContext smc) {
        System.out.println("Handler : handleMessage Called....");
        Boolean outboundProperty = (Boolean)smc.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);

        try {
            if (outboundProperty.booleanValue()) {
                System.out.println("Outbound message");
            } else {
                System.out.println("Inbound message");
            }
            
            SOAPMessage message = smc.getMessage();
            message.writeTo(System.out);
            System.out.println();
            
        } catch (Exception e) {
            System.out.println("Exception in handler: " + e);
        }       
        return true;
    }

    public boolean handleFault(SOAPMessageContext smc) {
        System.out.println("Handler : handleFault Called....");
        
        Boolean outboundProperty = (Boolean)smc.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
        if (outboundProperty.booleanValue()) {
            System.out.println("Outbound message");
        } else {
            System.out.println("Inbound message");
        }
        SOAPMessage message = smc.getMessage();
        try {
            message.writeTo(System.out);
        } catch (SOAPException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        System.out.println();
    
        return true;
    }

    public void close(MessageContext messageContext) {
        System.out.println("Handler : close() Called....");        
    }

}

